package test;

import java.util.ArrayList;
import java.util.List;

import util.io.FileParser;
import Jama.Matrix;

public class FixedCurve {

	public static final int LENGTH = 11;
	
	public static void main(String[] args){
		new FixedCurve(args[0],Integer.parseInt(args[1]));
	}
	
	public FixedCurve(String fileName,int accPos){
		FileParser parser = new FileParser();
		try{
			List<String> sequences = parser.extractRandomSequencesFromFile(fileName, -1);
			boolean notDone = true;
			
			List<Values> values = new ArrayList<Values>();
			
			//first, build up the values matrix
			for(int i=0;i<sequences.size()&&notDone;i++){
				String seq = sequences.get(i).toUpperCase();
				String substring = seq.substring(accPos-11,accPos);	//do not count AG's.
				//System.out.println(seq.substring(accPos-13,accPos-2));
				//System.out.println(seq.substring(accPos-11,accPos));
				Values val = new Values();
				
				for(int j=0;j<substring.length();j++){
					double p = Math.pow(LENGTH-j+1,j);
					char c = substring.charAt(j);
					switch(c){
					case 'A' : val.aValues[j] = p;	break;
					case 'C' : val.cValues[j] = p;	break;
					case 'G' : val.gValues[j] = p;	break;
					case 'T' : val.tValues[j] = p;	break;
					}
				}
				
				values.add(val);
				
				if(i==43)
					notDone = false;
				
			}
			
			//secondly, evaluate the matrix so you have the cuve variables.
			double[][] mat = createBaseMatrix(values);
			
			System.out.println(mat.length +" "+mat[0].length);
			for(int i=0;i<mat.length;i++){
				double[] temp = mat[i];
				for(int j=0;j<temp.length;j++){
					System.out.print(temp[j]+" ");
				}
				System.out.println();
			}
			
			double [][] ones = new double[mat.length][1];
			for(int i=0;i<ones.length;i++)
				ones[i][0] = 1;
			//double[][] mat2 = addResultingValues(mat);
			Matrix m1 = new Matrix(mat);
			Matrix m2 = new Matrix(ones);
			
			Matrix x = m1.solve(m2);
			x.chol();
			
			//x.print(x.getRowDimension(), x.getColumnDimension());
			
			
			
			
		}
		catch(Exception exc){
			exc.printStackTrace();
		}
	}
	
	public double[][] addResultingValues(double[][] original){
		double[][] result = new double[original.length][];
		for(int i=0;i<original.length;i++){
			double [] t = original[i];
			double [] tNew = new double[t.length+1];
			System.arraycopy(t, 0, tNew, 0, t.length);
			tNew[tNew.length-1] = 1;
			result[i] = tNew;
		}
		return result;
	}
	
	
	public double[][] createBaseMatrix(List<Values> vals){
		double [][] res = new double [vals.size()] [4*LENGTH];
		for(int i=0;i<vals.size();i++){
			Values val = vals.get(i);
			res[i] = getLine(val);
		}
		return res;
	}
	
	public double[] getLine(Values val){
		double[] res = new double[4*LENGTH];
		for(int i=0;i<LENGTH;i++){
			res[4*i] = val.aValues[i];
			res[4*i+1] = val.cValues[i];
			res[4*i+2] = val.gValues[i];
			res[4*i+3] = val.tValues[i];
		}
		
		return res;
	
	}
	
	public double[] getLine2(Values val){
		double [] res = new double [4*LENGTH];
		int offset = 0;
		for(int i=0;i<val.aValues.length;i++)
			res[offset+i] = val.aValues[i];
		offset = val.aValues.length;
		for(int i=0;i<val.cValues.length;i++)
			res[offset+i]= val.cValues[i];
		offset = val.aValues.length+val.cValues.length;
		for(int i=0;i<val.gValues.length;i++)
			res[offset+i] = val.gValues[i];
		offset = val.aValues.length+val.cValues.length+val.gValues.length;
		for(int i=0;i<val.tValues.length;i++)
			res[offset+i] = val.tValues[i];
		return res;
	}
	
	private class Values{
		public double []aValues = new double[LENGTH];
		public double []cValues = new double[LENGTH];
		public double []gValues = new double[LENGTH];
		public double []tValues = new double[LENGTH];
	}
	
}
