/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class SpliceFileInfo {

	public static void main(String[] args){
		new SpliceFileInfo(Integer.parseInt(args[0]));
	}
	
	public void splitFiles(){
		try{
			File oldDir = new File("./data/ectsi/full/");
			File newDir = new File("./data/ectsi/backup/");
			
			
			
			newDir.mkdirs();
			String[] files = oldDir.list();
			if(files==null || files.length==0){
				System.err.println("No files in directory");
				return;
			}
			for(int i=0;i<files.length;i++){
				if(files[i].endsWith(".pos")||files[i].endsWith(".neg")){
					File oldFile = new File(oldDir.getPath()+"\\"+files[i]);
					File newFile = new File(newDir.getPath()+"\\"+files[i]);
					
					BufferedReader reader = new BufferedReader(new FileReader(oldFile));
					BufferedWriter writer = new BufferedWriter(new FileWriter(newFile));
					
					String s = reader.readLine();
					while(s!=null){
						if(!s.startsWith(">")){
							writer.write(s+"\n");
						}
						s = reader.readLine();
					}
					reader.close();
					writer.close();
				}
			}
		}
		catch(Exception exc){
			System.err.println(exc);
			exc.printStackTrace();
		}
	}
	
	public void splitFiles2(){
		try{
			String oldDir = "./data/ectsi/full/";
			String newDir = "./data/ectsi/backup/";
			
			String oldNegAcc = "acceptors.ectsi.neg";
			String oldPosAcc = "acceptors.ectsi.pos";
			String oldNegDonGt = "donors.gt.ectsi.neg";
			String oldPosDonGt = "donors.gt.ectsi.pos";
			String oldNegDonGc = "donors.gc.ectsi.neg";
			String oldPosDonGc = "donors.gc.ectsi.pos";
			
			String newNegAcc = "acceptors.neg";
			String newPosAcc = "acceptors.pos";
			String newNegDon = "donors.neg";
			String newPosDon = "donors.pos";
			
			int number = 0;
			
			number = copyNormal(oldDir+oldPosAcc,newDir+newPosAcc);	//pos acceptors
			System.out.println("Positive acceptors extracted : "+number);
			number = copyNormal(oldDir+oldNegAcc,newDir+newNegAcc);	//neg acceptors
			System.out.println("Negative acceptors extracted : "+number);
			
			number = copyMerge(oldDir+oldPosDonGt,oldDir+oldPosDonGc,newDir+newPosDon);
			System.out.println("Positive donors extracted : "+number);
			number = copyMerge(oldDir+oldNegDonGt,oldDir+oldNegDonGc,newDir+newNegDon);
			System.out.println("Negative donors extracted : "+number);
			
			
			
		}
		catch(Exception exc){
			exc.printStackTrace();
		}
		
	}
	
	public int copyMerge(String from1,String from2,String to) throws Exception{
		File oldFile1 = new File(from1);
		File oldFile2 = new File(from2);
		File newFile = new File(to);
	
		BufferedReader reader1 = new BufferedReader(new FileReader(oldFile1));
		BufferedReader reader2 = new BufferedReader(new FileReader(oldFile2));
		BufferedWriter writer = new BufferedWriter(new FileWriter(newFile));
		
		String s1 = reader1.readLine();
		String s2 = reader2.readLine();
		
		int counter = 0;
		while(s1!=null || s2!=null){
			//System.out.println(s1==null+" "+s2==null);
			counter++;
			if(s1!=null && !s1.startsWith(">")){
				writer.write(s1+"\n");
			}
			if(s2!=null && !s2.startsWith(">")){
				writer.write(s2+"\n");
			}
			s2 = reader2.readLine();
			s1 = reader1.readLine();
		}
		reader1.close();
		reader2.close();
		writer.close();
		return counter;
	}
	
	
	
	
	
	
	public int copyNormal(String from,String to) throws Exception{
		File oldFile = new File(from);
		File newFile = new File(to);
	
		BufferedReader reader = new BufferedReader(new FileReader(oldFile));
		BufferedWriter writer = new BufferedWriter(new FileWriter(newFile));
		
		String s = reader.readLine();
		int counter = 0;
		while(s!=null){
			counter++;
			if(!s.startsWith(">")){
				writer.write(s+"\n");
			}
			s = reader.readLine();
		}
		reader.close();
		writer.close();
		return counter;
	}
	
	
	
	public SpliceFileInfo(int rule){
		if(rule == 1)
			splitFiles();
		else
			splitFiles2();
		
	}
	
	
	
	
}
