/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util.classificationFeatures.implementations;

import java.awt.Graphics2D;
import java.util.List;

import org.apache.batik.svggen.SVGGraphics2D;

import util.classificationFeatures.ClassificationFeatureDrawing;
import util.classificationFeatures.IncorrectClassificationFeatureException;

public class RFClassificationFeatureDrawing implements ClassificationFeatureDrawing{

	private RFClassificationFeature rcf = null;
	
	public RFClassificationFeatureDrawing(RFClassificationFeature rcf){
		this.rcf = rcf;
	}
	
	/**
	 * This method draws the 
	 * @param g2d
	 * @param list
	 * @throws IncorrectClassificationFeatureException
	 */
	public void draw(Graphics2D g2d, List<Integer> list ) throws IncorrectClassificationFeatureException{
		if(list.size()!=rcf.getNumberOfAttributes()){
			throw new IncorrectClassificationFeatureException();
		}
	}
	
	/**
	 * This method draws the scores assigned to each feature,
	 * that is generated by this corresponding ClassificationFeature. 
	 * 
	 * The normal idea is to let certain FeatureSelection methods assign
	 * a score to each feature, and then draw these scores in a
	 * classificationfeature dependend way.
	 * 
	 * @param svg
	 * @param list
	 * @throws IncorrectClassificationFeatureException
	 */
	public void draw(SVGGraphics2D svg, List<Double> list, int blocksize, int splicesite_increase) throws IncorrectClassificationFeatureException{
		
	}
}
