package util.io;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class ModelDataParser {

	
	public ModelDataParser(){
		
	}
	
	public List<ModelData> parseModelFile(String fileName) throws IOException{
		List<ModelData> list = new ArrayList<ModelData>();
		InputStream stream = this.getClass().getResourceAsStream(fileName);
		BufferedReader reader = new BufferedReader(new InputStreamReader(stream));
		String s = reader.readLine();
		while(s!=null){
			ModelData dat = getModelData(s);
			if(dat!=null)
				list.add(dat);
			s = reader.readLine();
		}
		reader.close();
		
		return list;
	}
	
	
	public ModelData getModelData(String s){
		ModelData dat = null;
		if(s==null)
			return null;
		if(s.startsWith("#"))
			return null;
		String []split1 = s.split("\t+");
		if(split1.length<3)
			return null;
		dat = new ModelData(split1[0],split1[1],split1[2]);
		/*if(split1.length<3)
			return null;
		String []split2 = new String[split1.length-2];
		for(int i=0;i<split2.length;i++)
			split2[i] = split1[i+2];
		dat = new ModelData(split1[0],split1[1],split2);*/
		return dat;
	}
	
	public class ModelData{
		
		private String species = null;
		private String purpose = null;
		private String locations = null;
		
		public ModelData(String species,String purpose,String locations){
			this.species = species;
			this.purpose = purpose;
			this.locations = locations;
		}

		public String getLocations() {
			return locations;
		}

		public void setLocations(String locations) {
			this.locations = locations;
		}

		public String getPurpose() {
			return purpose;
		}
		public void setPurpose(String purpose) {
			this.purpose = purpose;
		}

		
		public String getSpecies() {
			return species;
		}

		public void setSpecies(String species) {
			this.species = species;
		}
	}
	
}
