package var;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

public class SimpleExperimenter {

	private List<String> generalData  = null;
	private List<String> actionData	= null;
	
	private boolean rangeComplexity = true;
	
	public static void main(String[] args){
		try{
			new SimpleExperimenter(args);
		}
		catch(Exception exc){
			exc.printStackTrace();
		}
	}
	
	
	public SimpleExperimenter(String[] args)throws Exception{
		String standardFileName 	= args[0];
	//	String rangesFileName		= args[1]; 
		String outputFileName 		= args[1];
		int conclom			 		= Integer.parseInt(args[2]); 
		int com						= Integer.parseInt(args[3]);
		if(com==0)
			rangeComplexity = false;
		else
			rangeComplexity	= true;
		
		BufferedReader standardReader = new BufferedReader(new FileReader(new File(standardFileName)));
		retrieveStandardData(standardReader);

		
		
		if(conclom==0){	//add everything to the same file
			writeConclomZero(outputFileName);
			
		}
		else if(conclom==1){	//add only the same complexities to the same file
			writeConclomOne(outputFileName);
		}
		
	}
	

	public void writeConclomZero(String fileName)throws Exception{
		String[] features = {"P 1","P 2","P 3","C 2","C 3","C 4","C 5","C 6","RF"};
		int[] ranges = {0,20,40,60,80,100,120};
		boolean writeGeneral = true;
		
		String featureName = null;
		int upRange = 0;
		int downRange = 0;
		for(int i=0;i<features.length;i++){
			featureName = features[i];
			
			for(int j=0;j<ranges.length;j++){
				upRange = ranges[j];
				for(int k=0;k<ranges.length;k++){
					downRange = ranges[k];
					
					String res = "CLASSIFICATION_FEATURE\t\t"+ featureName+" "+upRange+" "+downRange;
					writeFull(writeGeneral,res,fileName);
					if(writeGeneral)
						writeGeneral = false;
				}
			}
		}
	}
	
	
	public void writeFull(boolean writeGeneral,String part,String outFile) throws Exception{
		double[] complexities = new double[15];
		for(int i=-10;i<=4;i++){
			complexities[i+10]=Math.pow(2, i);
		}
		if(rangeComplexity){
			for(int i=0;i<complexities.length;i++){
				String res = "CLASSIFIER_OPTIONS\t\t"+"-c "+complexities[i];
				List<String> temp = new ArrayList<String>();
				if(writeGeneral){
					for(int j=0;j<generalData.size();j++)
						temp.add(generalData.get(j));
				}
				for(int j=0;j<actionData.size();j++){
					temp.add(actionData.get(j));
				}
				temp.add(part);
				temp.add(res);
				temp.add("END\n");
				appendToFile(temp,outFile);
			}
		}
		else{
			
		}
	}
	
	public void appendToFile(List<String> data, String fileName) throws Exception{
		FileWriter writ = new FileWriter(new File(fileName),true);
		BufferedWriter writer = new BufferedWriter(writ);
		
		for(int i=0;i<data.size();i++)
			writer.write(data.get(i)+"\n");
		
		writer.flush();
		writer.close();
		writ.close();
	}
	
	public void writeConclomOne(String baseFileName)throws Exception{
		
	}
	
	public void retrieveStandardData(BufferedReader reader) throws Exception{
		generalData = new ArrayList<String>();
		actionData  = new ArrayList<String>();
		
		String s = reader.readLine();
		
		boolean firstEnd = false;
		while(s!=null && !s.startsWith("#")){
			if(!firstEnd&& !s.equals("END"))
				generalData.add(s);
			else if(!firstEnd && s.equals("END")){
				generalData.add(s);
				firstEnd = true;
			}
			else if(firstEnd && !s.equals("END")){
				actionData.add(s);
			}
			s = reader.readLine();
		}
	}

	
}
