package var.experimenter;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JPanel;

public class ActionPanel extends JPanel {

	public static final long serialVersionUID = 11557558l;
	
	private String name = null;
	private List<RangeOption> rangeOptions = new ArrayList<RangeOption>();
	private JPanel content = null;
	
	public ActionPanel(){
		super();
		content = new JPanel();
	}
	
	
	private void fillThisPanel(){
		Dimension d = new Dimension(1200,25*rangeOptions.size());
		content.setMinimumSize(d);
		content.setMaximumSize(d);
		content.setPreferredSize(d);
		
		Dimension smallDim = new Dimension(1190,25);
		content.setLayout(new GridLayout(rangeOptions.size(),1));
		for(int i=0;i<rangeOptions.size();i++){
			RangeOption rangeOption = rangeOptions.get(i);
			JPanel panel = rangeOption.createPanel(this,smallDim);
			content.add(panel);
		}
		this.add(content);
	}

	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public List<RangeOption> getRangeOptions() {
		return rangeOptions;
	}
	public void setRangeOptions(List<RangeOption> rangeOptions) {
		this.rangeOptions = rangeOptions;
		fillThisPanel();
	}
	
	
}
