package var.experimenter;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;


public class ChoosePanel extends JPanel implements ActionListener{

	public static final long serialVersionUID = 4456789l;
	
	private ScriptOptionAbstractClass single_option = null;
	private ScriptOptionAbstractClass fixed_range_option = null;
	private ScriptOptionAbstractClass range_exp_option = null;
	private ScriptOptionAbstractClass range_lin_option = null;
	private ScriptOptionAbstractClass current = null;
	
	private JRadioButton single_r_button = null;
	private JRadioButton fixed_range_r_button = null;
	private JRadioButton range_exp_r_button = null;
	private JRadioButton range_lin_r_button = null;
	
	private String title = null;
	
	public List<Double> getDoubleValues(){
		return current.getDoubleValues();
	}
	public List<Integer> getIntegerValues(){
		return current.getIntValues();
	}
	
	
	public String toString(){
		return title;
	}
	
	public boolean isRange(){
		if(current==single_option)
			return false;
		else
			return true;
	}
	
	public ChoosePanel(String title, ScriptOptionAbstractClass single, ScriptOptionAbstractClass fixed_range,
			ScriptOptionAbstractClass range_exp, ScriptOptionAbstractClass range_lin){
		super();
		this.title = title;
		single_option = single;
		fixed_range_option = fixed_range;
		range_exp_option = range_exp;
		range_lin_option = range_lin;
		current = single_option;
		
		JPanel contentPanel = makeContentPanel();
		JPanel buttonPanel = makeButtonPanel();
		
		this.setLayout(new BorderLayout());
		this.add(new JLabel(title),BorderLayout.NORTH);
		this.add(buttonPanel,BorderLayout.WEST);
		this.add(contentPanel,BorderLayout.CENTER);
		
	}
	
	public ChoosePanel(String title, ScriptOptionAbstractClass single, ScriptOptionAbstractClass fixed_range,
			ScriptOptionAbstractClass range_exp, ScriptOptionAbstractClass range_lin, int selected){
		super();
		this.title = title;
		single_option = single;
		fixed_range_option = fixed_range;
		range_exp_option = range_exp;
		range_lin_option = range_lin;
		
		if(selected == 0)
			current = single_option;
		else if(selected == 1)
			current = fixed_range_option;
		else if(selected == 2)
			current = range_exp_option;
		else if(selected == 3)
			current = range_lin_option;
		else
			current = single_option;
			 
		JPanel contentPanel = makeContentPanel();
		JPanel buttonPanel = makeButtonPanel();
		
		this.setLayout(new BorderLayout());
		this.add(new JLabel(title),BorderLayout.NORTH);
		this.add(buttonPanel,BorderLayout.WEST);
		this.add(contentPanel,BorderLayout.CENTER);
		
	}
	
	
	public JPanel makeContentPanel(){
		JPanel result = new JPanel();
		result.setLayout(new GridLayout(4,1));
		/*single_option.setEnabled(false);
		fixed_range_option.setEnabled(false);
		range_exp_option.setEnabled(false);
		range_lin_option.setEnabled(false);*/
		
		single_option.setVisible(false);
		fixed_range_option.setVisible(false);
		range_exp_option.setVisible(false);
		range_lin_option.setVisible(false);
		
		//current.setEnabled(true);
		current.setVisible(true);
		
		result.add(single_option);
		result.add(fixed_range_option);
		result.add(range_exp_option);
		result.add(range_lin_option);
		
		return result;
	}
	
	public JPanel makeButtonPanel(){
		JPanel result = new JPanel();
		single_r_button  		= new JRadioButton("Single value",true);
		fixed_range_r_button	= new JRadioButton("Fixed range ",false);
		range_exp_r_button 		= new JRadioButton("Exp range   ",false);
		range_lin_r_button		= new JRadioButton("Linear range",false);
		
		ButtonGroup group  = new ButtonGroup();
		group.add(single_r_button);
		group.add(fixed_range_r_button);
		group.add(range_exp_r_button);
		group.add(range_lin_r_button);
		
		result.setLayout(new GridLayout(4,1));
		result.add(single_r_button);
		result.add(fixed_range_r_button);
		result.add(range_exp_r_button);
		result.add(range_lin_r_button);
		
		single_r_button.addActionListener(this);
		fixed_range_r_button.addActionListener(this);
		range_exp_r_button.addActionListener(this);
		range_lin_r_button.addActionListener(this);
		
		return result;
	}
	
	public void actionPerformed(ActionEvent e){
	//	current.setEnabled(false);
		current.setVisible(false);
		
		if(e.getSource().equals(single_r_button))
			current = single_option;
		else if(e.getSource().equals(fixed_range_r_button))
			current = fixed_range_option;
		else if(e.getSource().equals(range_exp_r_button))
			current = range_exp_option;
		else if(e.getSource().equals(range_lin_r_button))
			current = range_lin_option;
		
		//current.setEnabled(true);
		current.setVisible(true);
	}

}
